HDU 5045 Contest DP+状态压缩

来源:互联网 发布:计算机编程语言 知乎 编辑:程序博客网 时间:2024/06/05 09:46

Contest

Time Limit : 2000/1000ms (Java/Other)   Memory Limit : 65536/65536K (Java/Other)
Total Submission(s) : 9   Accepted Submission(s) : 6

Font: Times New Roman | Verdana | Georgia

Font Size:  

Problem Description

In the ACM International Collegiate Programming Contest, each team consist of three students. And the teams are given 5 hours to solve between 8 and 12 programming problems. 

On Mars, there is programming contest, too. Each team consist of N students. The teams are given M hours to solve M programming problems. Each team can use only one computer, but they can’t cooperate to solve a problem. At the beginning of the ith hour, they will get the ith programming problem. They must choose a student to solve this problem and others go out to have a rest. The chosen student will spend an hour time to program this problem. At the end of this hour, he must submit his program. This program is then run on test data and can’t modify any more. 

Now, you have to help a team to find a strategy to maximize the expected number of correctly solved problems. 

For each problem, each student has a certain probability that correct solve. If the ith student solve the jth problem, the probability of correct solve is Pij .

At any time, the different between any two students’ programming time is not more than 1 hour. For example, if there are 3 students and there are 5 problems. The strategy {1,2,3,1,2}, {1,3,2,2,3} or {2,1,3,3,1} are all legal. But {1,1,3,2,3},{3,1,3,1,2} and {1,2,3,1,1} are all illegal. 

You should find a strategy to maximize the expected number of correctly solved problems, if you have know all probability

Input

The first line of the input is T (1 ≤ T ≤ 20), which stands for the number of test cases you need to solve.

The first line of each case contains two integers N ,M (1 ≤ N ≤ 10,1 ≤ M ≤ 1000),denoting the number of students and programming problem, respectively.

The next N lines, each lines contains M real numbers between 0 and 1 , the jth number in the ith line is Pij .

Output

For each test case, print a line “Case #t: ”(without quotes, t means the index of the test case) at the beginning. Then a single real number means the maximal expected number of correctly solved problems if this team follow the best strategy, to five digits after the decimal point. Look at the output for sample input for details.

Sample Input

12 30.6 0.3 0.40.3 0.7 0.9

Sample Output

Case #1: 2.20000

题意:n个人做m道题,每人人做一小时,第i个人做出第j题的概率是Pij, 求AC所有题的最大效率

思路:可以用dp来做,因为有最多10个人,而且每人做不同的题概率都不一定一样,所以用状态压缩记录做题状态,dp[i][j]表示前i题状态为j的最大值。

        已经做题了的暂时不能做,当每人都做一题后,状态置零。

<pre name="code" class="cpp">#include <stdio.h>#include <string.h>#include<algorithm>using namespace std;double p[15][1005], dp[1005][1<<10];double max(double a, double b){    if(a > b) return a;    return b;}int main(){    int n, m, t, i, j, k, s, tmp, cas;    double ans;    scanf("%d", &t);    cas = 1;    while(t--)    {        scanf("%d %d", &n, &m);        for(i = 1;i <= n;i++)            for(j = 1;j <= m;j++)                scanf("%lf", &p[i][j]);                        for(i = 0;i <= m;i++)            for(j = 0;j < (1<<n);j++)                dp[i][j] = -1;                dp[0][0] = 0;        for(i = 1;i <= m;i++)        {            for(j = 0;j < (1<<n);j++)            {                if(dp[i - 1][j] ==  -1) continue;//判断状态是否存在                for(k = 1;k <= n;k++)                {                    tmp = 1<<(k - 1); //第k人的二进制表示                     if(j&tmp) continue; //如果已经做过题                     s = j | tmp; //做题                    if(s == (1<<n) - 1) s = 0; // 全都做了一道,置零                     dp[i][s] = max(dp[i][s], dp[i - 1][j] + p[k][i]);                }            }        }        ans = 0.0;        for(i = 0;i < (1<<n);i++) ans = max(ans, dp[m][i]);        printf("Case #%d: %.5lf\n", cas++, ans);    }    return 0;}


0 0
原创粉丝点击